/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#ifndef __H264AVCCOMMONLIB_H_D64BE9B4_A8DA_11D3_AFE7_005004464B79
#define __H264AVCCOMMONLIB_H_D64BE9B4_A8DA_11D3_AFE7_005004464B79

#include "H264AVCCommonIf.h"


#if defined( MSYS_WIN32 )
  #if defined( H264AVCCOMMONLIB_EXPORTS )
    #define H264AVCCOMMONLIB_API __declspec(dllexport)
  #else
    #if !defined( H264AVCCOMMONLIB_LIB )
      #define H264AVCCOMMONLIB_API __declspec(dllimport)
    #else
      #define H264AVCCOMMONLIB_API
    #endif
  #endif
#elif defined( MSYS_LINUX )
  #define H264AVCCOMMONLIB_API
#endif

H264AVCCOMMONLIB_API extern UInt g_nSymbolCounter[16];
H264AVCCOMMONLIB_API extern UInt g_nLayer;


#define H264AVC_NAMESPACE_BEGIN      namespace h264 {
#define H264AVC_NAMESPACE_END        }



#include "H264AVCCommonLib/Macros.h"
#include "H264AVCCommonLib/GlobalFunctions.h"

#include "H264AVCCommonLib/CommonDefs.h"


#if defined( USE_NAMESPACE_H264AVC )
  using namespace h264;
#endif

#include "H264AVCCommonLib/CommonBuffers.h"
#include "H264AVCCommonLib/CommonTypes.h"
#include "H264AVCCommonLib/MbDataAccess.h"

#if defined( USE_NAMESPACE_H264AVC )
  using namespace h264;
#endif


#define H264AVCCommonLib_FIRST_VER      (0)
#define H264AVCCommonLib_SECOND_VER     (1)
#define H264AVCCommonLib_THIRD_VER      (0)
#define H264AVCCommonLib_FOURTH_VER     (0)


#endif //__H264AVCCOMMONLIB_H_D64BE9B4_A8DA_11D3_AFE7_005004464B79
