/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_CONTROLMNGIF_H__BB1C0D17_55C1_4629_B010_C22270D71001__INCLUDED_)
#define AFX_CONTROLMNGIF_H__BB1C0D17_55C1_4629_B010_C22270D71001__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

H264AVC_NAMESPACE_BEGIN

class MbDataCtrl;


class ControlMngIf
{
protected:
  ControlMngIf() {};
  virtual ~ControlMngIf() {};

public:
  virtual ErrVal initSlice0           (SliceHeader*                 rcSH )    = 0;
  virtual ErrVal initSPS              ( SequenceParameterSet&       rcSPS,
                                        UInt                        uiLayer ) = 0;

  virtual ErrVal initParameterSets    ( const SequenceParameterSet& rcSPS,
                                        const PictureParameterSet&  rcPPSLP,
                                        const PictureParameterSet&  rcPPSHP ) = 0;

  virtual ErrVal initSliceForCoding   ( const SliceHeader&  rcSH )        = 0;
  virtual ErrVal initSliceForReading  ( const SliceHeader&  rcSH )        = 0;
  virtual ErrVal initSliceForDecoding ( const SliceHeader&  rcSH )        = 0;
  virtual ErrVal initSliceForFiltering( const SliceHeader&  rcSH )        = 0;
  virtual ErrVal initSliceForWeighting( const SliceHeader&  rcSH )        = 0;
  virtual ErrVal finishSlice          ( const SliceHeader&  rcSH,
                                        Bool&               rbPicDone,
                                        Bool&               rbFrameDone ) = 0;

  virtual ErrVal initMbForParsing     ( MbDataAccess*& rpcMbDataAccess, UInt uiMbIndex )                      = 0;
  virtual ErrVal initMbForDecoding    ( MbDataAccess*& rpcMbDataAccess, UInt uiMbY, UInt uiMbX, Bool bMbAff ) = 0;
  virtual ErrVal initMbForFiltering   ( MbDataAccess*& rpcMbDataAccess, UInt uiMbY, UInt uiMbX, Bool bMbAff ) = 0;

  virtual ErrVal initMbForCoding      ( MbDataAccess& rcMbDataAccess, UInt uiMbY, UInt uiMbX, Bool bMbAff, Bool bFieldFlag )  = 0;
  virtual ErrVal initMbForDecoding    ( MbDataAccess& rcMbDataAccess, UInt uiMbY, UInt uiMbX, Bool bMbAff )                   = 0;
  virtual ErrVal initMbForFiltering   ( MbDataAccess& rcMbDataAccess, UInt uiMbY, UInt uiMbX, Bool bMbAff )                   = 0;
};


H264AVC_NAMESPACE_END


#endif // !defined(AFX_CONTROLMNGIF_H__BB1C0D17_55C1_4629_B010_C22270D71001__INCLUDED_)
