/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_GLOBALFUNCTIONS_H__85D028A1_590E_423B_9072_AB351037B1E8__INCLUDED_)
#define AFX_GLOBALFUNCTIONS_H__85D028A1_590E_423B_9072_AB351037B1E8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define min(x,y) ((x)<(y)?(x):(y))
#define max(x,y) ((x)>(y)?(x):(y))

H264AVC_NAMESPACE_BEGIN

__inline
UInt gCeilLog2( const UInt uiVal )
{
  UInt uiTmp = uiVal-1;
  UInt uiRet = 0;
  AOT_DBG( uiTmp == 0);

  AOT_DBG( uiTmp == 0);

  while( uiTmp != 0 )
  {
    uiTmp >>= 1;
    uiRet++;
  }
  return uiRet;
}

__inline
Bool gBoolRandom()
{
  return 0 == (rand()&1);
}

__inline
const Int gClip( const Int iX )
{
  const Int i2 = (iX & 0xFF);
  if( i2 == iX )  { return iX; }
  if( iX < 0 )    { return 0x00; }
  else            { return 0xFF; }
}


__inline
const Int gClipMinMax( const Int iX, const Int iMin, const Int iMax )
{
  return max( min( iX, iMax ), iMin );
}

//TMM_WP
__inline
Int gIntRandom(const Int iMin, const Int iMax)
{
    Double fRange = (Double)(iMax - iMin + 1);
    Int iValue = (Int)(fRange*(Double)rand()/(Double)(RAND_MAX+1.0));

    AOT_DBG( (iValue + iMin)> iMax );
    return iValue + iMin;
}
//TMM_WP

// JVT-V068 HRD {
__inline
Int gGetNumberOfLSBZeros( UInt ui )
{
  ROTRS( ui == 0, 0);
  for( Int i = 0; ; i++)
  {
    ROTRS( (ui&1) == 1, i);
    ui >>= 1;
  }
}
// JVT-V068 HRD }

H264AVC_NAMESPACE_END


#endif // !defined(AFX_GLOBALFUNCTIONS_H__85D028A1_590E_423B_9072_AB351037B1E8__INCLUDED_)
