/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_POCCALCULATOR_H__5D005452_8A6E_4482_B502_D20DA8FAE6B0__INCLUDED_)
#define AFX_POCCALCULATOR_H__5D005452_8A6E_4482_B502_D20DA8FAE6B0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



H264AVC_NAMESPACE_BEGIN



class H264AVCCOMMONLIB_API PocCalculator
{
public:
  PocCalculator();

  static  ErrVal  create  ( PocCalculator*& rpcPocCalculator );
  ErrVal  copy            ( PocCalculator*& rpcPocCalculator );
  ErrVal  destroy         ();

  ErrVal  setPoc          ( SliceHeader& rcSliceHeader, Int iContNumber );
  ErrVal  calculatePoc    ( SliceHeader& rcSliceHeader );
  ErrVal  resetMMCO5      ( SliceHeader& rcSliceHeader );

protected:
  ErrVal  xInitSPS        ( const SequenceParameterSet& rcSPS );

private:
  UInt    m_iLastIdrFieldNum;
  Int     m_iBitsLsb;
  Int     m_iTop2BotOffset;

  Int     m_iPrevRefPocMsb;
  Int     m_iPrevRefPocLsb;
  Int     m_iMaxPocLsb;
  Int     m_iFrameNumOffset;
  Int     m_iRefOffsetSum;
  Int     m_iPrevFrameNum;
};


H264AVC_NAMESPACE_END


#endif // !defined(AFX_POCCALCULATOR_H__5D005452_8A6E_4482_B502_D20DA8FAE6B0__INCLUDED_)
