/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_RECONSTRUCTIONBYPASS_H__A1FD51F1_158E_45AF_93DE_35EF82E2A708__INCLUDED_)
#define AFX_RECONSTRUCTIONBYPASS_H__A1FD51F1_158E_45AF_93DE_35EF82E2A708__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


H264AVC_NAMESPACE_BEGIN

class Frame;
class YuvMbBufferExtension;
class MbDataCtrl;
class YuvBufferCtrl;

class ReconstructionBypass
{
public:
  ReconstructionBypass();
  virtual ~ReconstructionBypass() {}

  static ErrVal create( ReconstructionBypass*& rpcReconstructionBypass );

  ErrVal destroy();
  ErrVal init();
  ErrVal uninit();

  ErrVal padRecFrame( Frame*             pcFrame,
                      const MbDataCtrl*  pcMbDataCtrl,
                      ResizeParameters*  pcResizeParameters,
                      UInt               uiSliceId = MSYS_UINT_MAX );

private:
  ErrVal xPadRecMb        ( YuvMbBufferExtension* pcBuffer, UInt uiMask );
  ErrVal xPadRecMb_MbAff  ( YuvMbBufferExtension* pcBuffer, UInt uiMask );
  ErrVal xPad8x8Blk_MbAff ( YuvMbBufferExtension* pcBuffer, UInt ui8x8Blk, Bool bV0, Bool bV1, Bool bH, Bool bC0, Bool bC1 );
  ErrVal xPadBlock_MbAff  ( YuvMbBufferExtension* pcBuffer, LumaIdx cIdx, Bool bVer, Bool bHor, Bool bCorner, Bool bHalfYSize, Bool bFromAbove, Bool bFromLeft );

  Bool   xRequiresOutsidePadding( UInt uiMbX, UInt uiMbY, UInt uiFrameWidth, UInt uiFrameHeight, Bool bMbAff, UInt uiOrgMask, UInt* pauiMask );
  ErrVal xOutshiftMask          ( Bool bMbAff, UInt uiDir, UInt uiOrgMask, UInt& ruiShiftedMask );
};

H264AVC_NAMESPACE_END


#endif // !defined(AFX_RECONSTRUCTIONBYPASS_H__A1FD51F1_158E_45AF_93DE_35EF82E2A708__INCLUDED_)
