/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_READBITSTREAMIF_H__A16C5223_7579_474B_A554_3A6FAEA78126__INCLUDED_)
#define AFX_READBITSTREAMIF_H__A16C5223_7579_474B_A554_3A6FAEA78126__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class H264AVCVIDEOIOLIB_API ReadBitstreamIf
{
public:
  ReadBitstreamIf() {};
  virtual ~ReadBitstreamIf() {};

  virtual ErrVal extractPacket( BinData*& rpcBinData, Bool& rbEOS ) = 0;
  virtual ErrVal releasePacket( BinData* pcBinData ) = 0;

  virtual ErrVal getPosition( Int& iPos ) = 0;
  virtual ErrVal setPosition( Int  iPos ) = 0;
  virtual Int64  getFilePos ()            = 0;

  virtual ErrVal uninit() = 0;
  virtual ErrVal destroy() = 0;

};

#endif // !defined(AFX_READBITSTREAMIF_H__A16C5223_7579_474B_A554_3A6FAEA78126__INCLUDED_)
