/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_DECERROR_H__19223BF1_DA9C_475F_9AEE_D1A55237EB1E__INCLUDED_)
#define AFX_DECERROR_H__19223BF1_DA9C_475F_9AEE_D1A55237EB1E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#if defined (FAULT_TOLERANT)
 #define DECASSERT(x)
#else
 #define DECASSERT(x) ASSERT(x)
#endif


#define DECROF( exp )         \
{                             \
  if( !( exp ) )              \
  {                           \
    DECASSERT( 0 );           \
    return ERR_CLASS::m_nERR; \
  }                           \
}

#define DECROT( exp )         \
{                             \
  if( ( exp ) )               \
  {                           \
    DECASSERT( 0 );           \
    return ERR_CLASS::m_nERR; \
  }                           \
}


#define DECROFR( exp, retVal )   \
{                             \
  if( !( exp ) )              \
  {                           \
    DECASSERT( 0 );           \
    return retVal;            \
  }                           \
}

#define DECROTR( exp, retVal )   \
{                             \
  if( ( exp ) )               \
  {                           \
    DECASSERT( 0 );           \
    return retVal;            \
  }                           \
}


#define DECROFV( exp )        \
{                             \
  if( !( exp ) )              \
  {                           \
    DECASSERT( 0 );           \
    return;                   \
  }                           \
}

#define DECROTV( exp )        \
{                             \
  if( ( exp ) )               \
  {                           \
    DECASSERT( 0 );           \
    return;                   \
  }                           \
}

#if JVT_U125
#define DECRNOK( exp )            \
{                                 \
  const ERR_VAL nMSysRetVal = ( exp );   \
  if( ERR_CLASS::m_nOK != nMSysRetVal )  \
  {                               \
    return nMSysRetVal;           \
  }                               \
}
#else
#define DECRNOK( exp )            \
{                                 \
  const ERR_VAL nMSysRetVal = ( exp );   \
  if( ERR_CLASS::m_nOK != nMSysRetVal )  \
  {                               \
    DECASSERT( 0 );               \
    return nMSysRetVal;           \
  }                               \
}
#endif

#define DECRNOKR( exp, retVal )     \
{                                   \
  if( ERR_CLASS::m_nOK != ( exp ) ) \
  {                                 \
    DECASSERT( 0 );                 \
    return retVal;                  \
  }                                 \
}


#define DECRNOKV( exp )             \
{                                   \
  if( ERR_CLASS::m_nOK != ( exp ) ) \
  {                                 \
    DECASSERT( 0 );                 \
    return;                         \
  }                                 \
}


#endif // !defined(AFX_DECERROR_H__19223BF1_DA9C_475F_9AEE_D1A55237EB1E__INCLUDED_)
