/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_MBPARSER_H__C2625057_4318_4267_8A7A_8185BB75AA7F__INCLUDED_)
#define AFX_MBPARSER_H__C2625057_4318_4267_8A7A_8185BB75AA7F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


H264AVC_NAMESPACE_BEGIN

class Transform;
class MbSymbolReadIf;

class MbParser
{
protected:
	MbParser();
	virtual ~MbParser();

public:
  static ErrVal create  ( MbParser*&      rpcMbParser );
  ErrVal        destroy ();
  ErrVal        init    ();
  ErrVal        uninit  ();

  ErrVal initSlice      ( MbSymbolReadIf* pcMbSymbolReadIf );
  ErrVal read           ( MbDataAccess&   rcMbDataAccess,
                          UInt            uiNumMbRead,
                          Bool&           rbEndOfSlice );

protected:
  Bool   xCheckSkipSliceMb            ( MbDataAccess& rcMbDataAccess, UInt uiNumMbRead, Bool& rbEndOfSlice );
  ErrVal xSkipMb                      ( MbDataAccess& rcMbDataAccess );
  ErrVal xReadIntraPredModes          ( MbDataAccess& rcMbDataAccess );

  ErrVal xReadTextureInfo             ( MbDataAccess& rcMbDataAccess, Bool bTrafo8x8Flag, Bool bBaseLayerAvailable, UInt uiStart = 0, UInt uiStop = 16 );
  ErrVal xScanChromaBlocks            ( MbDataAccess& rcMbDataAccess, UInt uiChromCbp, UInt uiStart = 0, UInt uiStop = 16 );
  ErrVal xReadMotionVectors           ( MbDataAccess& rcMbDataAccess, MbMode  eMbMode, ListIdx eLstIdx );
  ErrVal xReadReferenceFramesNoRefPic ( MbDataAccess& rcMbDataAccess, MbMode  eMbMode, ListIdx eLstIdx );
  ErrVal xReadMotionPredFlags         ( MbDataAccess& rcMbDataAccess, MbMode  eMbMode, ListIdx eLstIdx );
  ErrVal xGet8x8BlockMv               ( MbDataAccess& rcMbDataAccess, B8x8Idx c8x8Idx, ListIdx eLstIdx );

protected:
  Bool            m_bInitDone;
  MbSymbolReadIf* m_pcMbSymbolReadIf;
  Bool            m_bPrevIsSkipped;
};


H264AVC_NAMESPACE_END


#endif // !defined(AFX_MBPARSER_H__C2625057_4318_4267_8A7A_8185BB75AA7F__INCLUDED_)
