/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_BITWRITEBUFFERIF_H__7F264021_5671_490D_8B36_571A1F6E3E38__INCLUDED_)
#define AFX_BITWRITEBUFFERIF_H__7F264021_5671_490D_8B36_571A1F6E3E38__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000



H264AVC_NAMESPACE_BEGIN


class BitWriteBufferIf
{
protected:
  BitWriteBufferIf() {}
  virtual ~BitWriteBufferIf() {}

public:
  virtual ErrVal write( UInt uiBits, UInt uiNumberOfBits = 1) = 0;
  virtual BitWriteBufferIf* getNextBitWriteBuffer( Bool bStartNewBitstream = false ) = 0;
  virtual Bool nextBitWriteBufferActive() = 0;
  virtual UChar* getNextBuffersPacket() = 0;

  virtual UInt getNumberOfWrittenBits() = 0 ;

  virtual ErrVal writeAlignZero() = 0;
  virtual ErrVal writeAlignOne() = 0;
  virtual ErrVal flushBuffer() = 0;
  virtual ErrVal pcmSamples( const TCoeff* pCoeff, UInt uiNumberOfSamples ) = 0;
  virtual ErrVal getLastByte(UChar &uiLastByte, UInt &uiLastBitPos) = 0; //FIX_FRAG_CAVLC
	//JVT-X046 {
	virtual void loadBitWriteBuffer(BitWriteBufferIf* pcBitWriteBufferIf) = 0;
	virtual void loadBitCounter(BitWriteBufferIf* pcBitWriteBufferIf) = 0;
	virtual UInt getBitsWritten(void) = 0;
	//JVT-X046 }
};



H264AVC_NAMESPACE_END


#endif // !defined(AFX_BITWRITEBUFFERIF_H__7F264021_5671_490D_8B36_571A1F6E3E38__INCLUDED_)
