/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_MBTEMPDATA_H__2D7469B9_B5A8_44FE_AA77_6BA0269C8F37__INCLUDED_)
#define AFX_MBTEMPDATA_H__2D7469B9_B5A8_44FE_AA77_6BA0269C8F37__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "H264AVCCommonLib/YuvMbBuffer.h"


H264AVC_NAMESPACE_BEGIN



class IntMbTempData :
public CostData
, public MbData
, public MbTransformCoeffs
, public YuvMbBuffer
{
public:
	IntMbTempData               ();
	virtual ~IntMbTempData      ();

  ErrVal  init                ( MbDataAccess& rcMbDataAccess );

  ErrVal  uninit              ();

  Void    clear               ();
  Void    clearCost           ();

  UInt&   cbp                 ()                { return m_uiMbCbp; }

  Void    copyTo              ( MbDataAccess&   rcMbDataAccess );
  Void    loadChromaData      ( IntMbTempData&  rcMbTempData );

  Void    copyResidualDataTo  ( MbDataAccess&   rcMbDataAccess );

  MbMotionData&       getMbMotionData   ( ListIdx eLstIdx ) { return m_acMbMotionData [ eLstIdx ]; }
  MbMvData&           getMbMvdData      ( ListIdx eLstIdx ) { return m_acMbMvdData    [ eLstIdx ]; }
  YuvMbBuffer&     getTempYuvMbBuffer()                  { return m_cTempYuvMbBuffer; }
  MbDataAccess&       getMbDataAccess   ()                  { AOF_DBG(m_pcMbDataAccess); return *m_pcMbDataAccess; }
  const SliceHeader&  getSH             ()            const { AOF_DBG(m_pcMbDataAccess); return m_pcMbDataAccess->getSH(); }
  const CostData&     getCostData       ()            const { return *this; }
  operator MbDataAccess&                ()                  { AOF_DBG(m_pcMbDataAccess); return *m_pcMbDataAccess; }
  operator YuvMbBuffer*              ()                  { return this; }

protected:
  MbDataAccess*       m_pcMbDataAccess;
  MbMvData            m_acMbMvdData[2];
  MbMotionData        m_acMbMotionData[2];
  YuvMbBuffer      m_cTempYuvMbBuffer;
};


H264AVC_NAMESPACE_END


#endif // !defined(AFX_MBTEMPDATA_H__2D7469B9_B5A8_44FE_AA77_6BA0269C8F37__INCLUDED_)
