/*
********************************************************************************

This software module was originally developed by

Heiko Schwarz    (Fraunhofer HHI),
Tobias Hinz      (Fraunhofer HHI),
Karsten Suehring (Fraunhofer HHI)

in the course of development of the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video
Coding) for reference purposes and its performance may not have been optimized.
This software module is an implementation of one or more tools as specified by
the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding).

Those intending to use this software module in products are advised that its
use may infringe existing patents. ISO/IEC have no liability for use of this
software module or modifications thereof.

Assurance that the originally developed software module can be used
(1) in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) once the
ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) has been adopted; and
(2) to develop the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding): 

To the extent that Fraunhofer HHI owns patent rights that would be required to
make, use, or sell the originally developed software module or portions thereof
included in the ISO/IEC 14496-10:2005 Amd.1 (Scalable Video Coding) in a
conforming product, Fraunhofer HHI will assure the ISO/IEC that it is willing
to negotiate licenses under reasonable and non-discriminatory terms and
conditions with applicants throughout the world.

Fraunhofer HHI retains full right to modify and use the code for its own
purpose, assign or donate the code to a third party and to inhibit third
parties from using the code for products that do not conform to MPEG-related
ITU Recommendations and/or ISO/IEC International Standards. 

This copyright notice must be included in all copies or derivative works.
Copyright (c) ISO/IEC 2005. 

********************************************************************************
*/


#if !defined(AFX_MOTIONESTIMATIONQUARTERPEL_H__3CDE908E_D756_4E9A_8B86_C55174766C93__INCLUDED_)
#define AFX_MOTIONESTIMATIONQUARTERPEL_H__3CDE908E_D756_4E9A_8B86_C55174766C93__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


#include "MotionEstimation.h"
#define X1 24


H264AVC_NAMESPACE_BEGIN

class MotionEstimationQuarterPel :
public MotionEstimation
{
protected:
  MotionEstimationQuarterPel();
  virtual ~MotionEstimationQuarterPel();

public:
  static ErrVal create( MotionEstimation*& rpcMotionEstimation );

  ErrVal compensateBlock( YuvMbBuffer *pcRecPelData, UInt uiBlk, UInt uiMode, YuvMbBuffer *pcRefPelData2 = NULL );

  Void xSubPelSearch( YuvPicBuffer *pcPelData, Mv& rcMv, UInt& ruiSAD, UInt uiBlk, UInt uiMode, Bool bQPelOnly );

protected:
  Void xCompensateBlocksHalf( XPel *pPelDes, YuvPicBuffer *pcRefPelData, Mv cMv, UInt uiMode, UInt uiYSize, UInt uiXSize );
  Void xGetSizeFromMode( UInt& ruiXSize, UInt& ruiYSize, UInt uiMode );
  Void xInitBuffer();

protected:
  UInt m_uiBestMode;
  XPel m_aXHPelSearch[17*X1*4];
  XPel m_aXQPelSearch[16*16*9];
  XPel *m_apXHPelSearch[9];
  XPel *m_apXQPelSearch[9];
};


H264AVC_NAMESPACE_END


#endif // !defined(AFX_MOTIONESTIMATIONQUARTERPEL_H__3CDE908E_D756_4E9A_8B86_C55174766C93__INCLUDED_)
